{
=============================================================================
| THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  |
| AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    |
| IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   |
| ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR  |
| ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL       |
| DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR   |
| SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER   |
| CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT           |
| LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY    |
| OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  |
| DAMAGE.                                                                      |
=============================================================================
   Author:  D.J.C. Blijker.
   Date:    22-4-2003
   version: 1.0
   e-mail:  c.blijker@wxs.nl
=============================================================================
This application serves as an example of an implementation of the THxLogClient
class.
=============================================================================
}
unit LogClient_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LogClient_LogicLayer, StdCtrls, ExtCtrls, Spin, Buttons;

type
  TfrmMain = class(TForm)
    mmo: TMemo;
    edtMessage: TEdit;
    cbxStartTimer: TCheckBox;
    tmr: TTimer;
    Bevel1: TBevel;
    Label1: TLabel;
    speSwitchTime: TSpinEdit;
    Bevel2: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel3: TBevel;
    Label4: TLabel;
    edtLogFileName: TEdit;
    Label5: TLabel;
    speMaxSerNr: TSpinEdit;
    Bevel4: TBevel;
    btnSetLogfileName: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbxStartTimerClick(Sender: TObject);
    procedure tmrTimer(Sender: TObject);
    procedure speSwitchTimeChange(Sender: TObject);
    procedure speMaxSerNrChange(Sender: TObject);
    procedure btnSetLogfileNameClick(Sender: TObject);
  private
    { Private declarations }
    lc: THxLogClient;
    procedure ShowError( Sender: TObject; sMess: string);
    procedure ShowConnection(Sender: TObject);
    procedure ShowConnectionClosed(Sender: TObject);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  lc := THxLogClient.Create;
  lc.OnError := ShowError;
  lc.OnConnection := ShowConnection;
  lc.OnConnectionClosed := ShowConnectionClosed;
end;

procedure TfrmMain.ShowError( Sender: TObject; sMess: string );
begin
  mmo.Lines.Add( sMess );
end;

procedure TfrmMain.ShowConnection( Sender: TObject );
begin
  mmo.Lines.Add('Connection with the log-daemon established');
end;

procedure TfrmMain.ShowConnectionClosed( Sender: TObject );
begin
  mmo.Lines.Add('Connection with the log-daemon lost');
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  lc.Free;
end;

procedure TfrmMain.cbxStartTimerClick(Sender: TObject);
begin
  tmr.Enabled := cbxStartTimer.Checked;
  if cbxStartTimer.Checked then
    mmo.Lines.Add('timer active')
  else
    mmo.Lines.Add('Timer NOT active');
end;

procedure TfrmMain.tmrTimer(Sender: TObject);
begin
  if edtMessage.Text <> '' then
    lc.LogStr( edtMessage.Text );
end;

procedure TfrmMain.speSwitchTimeChange(Sender: TObject);
var
  iSwitchTime: integer;
begin
  try
    iSwitchTime := speSwitchTime.Value;
    lc.SetLogSwitchTime( iSwitchTime );
  except
    // ignore..
  end;
end;

procedure TfrmMain.speMaxSerNrChange(Sender: TObject);
var
  iMaxNr: integer;
begin
  try
    iMaxNr := speMaxSerNr.Value;
    lc.UseNrOfLogs( iMaxNr );
  except
    // ignore..
  end;
end;

procedure TfrmMain.btnSetLogfileNameClick(Sender: TObject);
begin
  if edtLogFileName.Text <> '' then
    lc.UseLogFileName( edtLogFileName.Text );
end;

end.
